; HISTORY OF CHANGE:
;   05.07.86    Makros in Unterroutinen verwandelt. Diese Art von
;               Makros kennt nur der Metacomco Assembler. (glasi)
;   06.07.86    Test auf Laufwerk D eingbaut. Terminiert, wenn
;               Ramdisk das aktuelle Laufwerk ist (glasi)
;   01.05.89    Ramdisklaufwerk jetzt 'G'
;               Assembler: jetzt Profimat (ju)


; ROMDISK-Kopierprogramm fuer ATARI ST.  (c) 1986 GvS
; 14. Juni 1986


; Definition von Konstanten

DRVNUM: EQU     6               ; Laufwerk G

GEMDOS: EQU     1               ; GEMDOS TRAP #
BIOS:   EQU     13              ; BIOS TRAP #

CONIN:  EQU     1               ; GEMDOS #  1: Zeichen einlesen
PRLIN:  EQU     9               ; GEMDOS #  9: String ausgeben
GETDRV  EQU     $19             ; GEMDOS       Drivenummer liefern
CREATE: EQU     $3C             ; GEMDOS #$3C: Datei erstellen
CLOSE:  EQU     $3E             ; GEMDOS #$3E: Datei scliessen
WRITE:  EQU     $40             ; GEMDOS #$40: Puffer in Datei schreiben
RWABS:  EQU     4               ; BIOS #4: Sektoren lesen/schreiben
        PAGE


; Hauptprogramm

        TEXT
ROMCPY: MOVE    #GETDRV,-(SP)
        TRAP    #GEMDOS
        ADDQ.L  #2,SP
        CMP     #DRVNUM,D0
        BNE     ROK
        LEA     DERROR,A0
        BRA     TERM
ROK     LEA     FNAME,A0        ; Adresse des Dateinamens
        BSR     CREFIL          ; Datei erstellen
        CLR.L   D7              ; Start bei Sektor 0
ROMC1   MOVEQ   #15,D6          ; Anzahl der zu lesenden 4 KByte-Bloecke
ROMC2   BSR     RDSECS          ; 8 Sektoren lesen
        BSR     WRTBUF          ; Puffer in Datei schreiben
        DBRA    D6,ROMC2        ;
        BSR     CLSFIL          ; Datei schliessen
        LEA     FNAME1,A0       ; Adresse des 2. Dateinamens
        BSR     CREFIL          ; 2. Datei erstellen
        BRA     ROMC1           ; Das selbe nochmal


; - CREFIL -- Datei neu erstellen
; Eingaben:     A0 - Adresse des Dateinamens

CREFIL: CLR     -(SP)           ; Datei Attribut: Lesen / Schreiben
        MOVE.L  A0,-(SP)        ; Adresse des Dateinamens
        MOVE    #CREATE,-(SP)   ; Datei neu erstellen
        TRAP    #GEMDOS         ; GEMDOS aufrufen
        ADDQ.L  #8,SP           ; Stack zureucksetzen
        TST     D0              ; Fehler aufgetreten
        BMI     CREF1           ; Ja
        MOVE    D0,HANDLE       ; File Handle merken
        RTS                     ;
CREF1   LEA     CREERR,A0
TERM    BSR     PRSTR
;
TERM1:  LEA     EXITMS,A0
        BSR     PRSTR           ; Zeichenkette ausgeben
        MOVE    #CONIN,-(SP)    ; Zeichen einlesen
        TRAP    #GEMDOS         ; GEMDOS aufrufen
        ADDQ.L  #2,SP           ; Stack zuruecksetzen
        CLR     -(SP)           ; Programm abbrechen
        TRAP    #GEMDOS         ; GEMDOS aufrufen


; - RDSECS -- Sektoren von der RAM-Disk lesen
; Eingaben:     D7 - Logische Sektornummer

RDSECS: MOVE    #DRVNUM,-(SP)   ; Nummer des Laufwerks
        MOVE    D7,-(SP)        ; Logische Sektornummer
        MOVE    #8,-(SP)        ; 8 Sektoren bearbeiten
        PEA     DSKBUF          ; Adresse des Zielpuffers
        CLR     -(SP)           ; Lesezugriff
        MOVE    #RWABS,-(SP)    ; Sektoren lesen
        TRAP    #BIOS           ; BIOS aufrufen
        ADD.L   #14,SP          ; Stack zuruecksetzen
        TST     D0              ; Fehler aufgetreten ?
        BMI     RDS1            ; Ja
        ADDQ    #8,D7           ; Sektornummer um 8 erhoehen
        RTS                     ;
RDS1    LEA     RDERR,A0
        BRA     TERM            ; Programm beenden


; - WRTBUF -- Sektorpuffer auf Diskette speichern

WRTBUF: PEA     DSKBUF          ; Adresse des Puffers
        MOVE.L  #4096,-(SP)     ; Groesse des Puffers
        MOVE    HANDLE,-(SP)    ; Datei Handle
        MOVE    #WRITE,-(SP)    ; Datei beschreiben
        TRAP    #GEMDOS         ; GEMDOS aufrufen
        ADD.L   #12,SP          ; Stack zuruecksetzen
        TST     D0              ; Fehler aufgetreten ?
        BMI     WRT1            ; Ja
        RTS                     ;
WRT1    LEA     WRTERR,A0
        BRA     TERM            ; Programm beenden


; - CLSFIL -- Datei schliessen
; Eingaben:     D7 - Logische Sektornummer

CLSFIL: MOVE    HANDLE,-(SP)    ; Datei Handle
        MOVE    #CLOSE,-(SP)    ; Datei schliessen
        TRAP    #GEMDOS         ; GEMDOS aufrufen
        ADDQ.L  #4,SP           ; Stack zuruecksetzen
        CMP     #128,D7         ; Sektornummer > 128 ?
        BGT     CLS1            ; Ja
        RTS                     ;
CLS1    BRA     TERM            ; Programm beenden


PRSTR   MOVE.L  A0,-(SP)        ; - Zeichenkette ausgeben - 
        MOVE    #PRLIN,-(SP)    ; String ausgeben
        TRAP    #GEMDOS         ; GEMDOS aufrufen
        ADDQ.L  #6,SP           ; Stack zuruecksetzen
        RTS


; Fehlermeldungen

        DATA
FNAME:  DC.B    "ROMDISK1.DAT",0
FNAME1: DC.B    "ROMDISK2.DAT",0
EXITMS: DC.B    "Weiter mit <RETURN> ",0
DERROR: DC.B    "Bitte anderes Laufwerk benutzen",13,10,0
CREERR: DC.B    "Fehler beim Erstellen der Datei",13,10,0
RDERR:  DC.B    "Fehler beim Lesen",13,10,0
WRTERR: DC.B    "Fehler beim Schreiben",0


; Puffer

        BSS
HANDLE: DS.W    1
DSKBUF: DS.B    4096
        END




