; HISTORY OF CHANGE:
;   04.07.86    Lokale Label entfernt, weil der verdammte DRI Assembler
;               keine lokalen Label kennt. (glasi)
;   04.07.86   ';' nach '*' geaendert, der verdammte..... (glasi)
;   04.07.86    In ROMDS1: Test auf Vorhandensein von EPROMS.
;               falls nicht, terminate mit 0 Bytes (glasi)
;   04.07.86    In ROMDS1: Test ob Treiber bereits installiert, Wenn
;               ja, terminate mit 0 Bytes (glasi)
;   04.07.86    Near ROMDSK: Speicherberechnung geaendert, kein data
;               und bss, also auch keine Berechnung (glasi)
;   04.07.86    Init Routine hinter Treiber gelegt, braucht nicht im
;               Speicher zu bleiben (glasi)
;   05.07.86    return -1L bei Schreibversuch, korrekt waere -13L,
;               komischerweise reagiert TOS dann nicht (glasi)
;               Bpb nach vorne verlegt (glasi)
;   05.07.85    Speedup der Transferroutine ca. 40% -- Load-
;               processing geschieht immer an geradebn Adressen (glasi)
;   05.07.86    SAVEAREAS  in den Treiber verlegt (glasi)
;   01.05.89    ROM-DISK jetzt Laufwerk 'G' (ju)
;               FAT: 1 Sek., DIR: 1 Sek (ju)
;               Assembler: Profimat

; ROMDISK-Treiber fuer ATARI ST.  (c) 1986 GvS
; 14.Juni 1986


; Definition von Konstanten

HDVBPB  EQU     $472            ; Adresse des BPB-Vektors
HDVRW   EQU     $476            ; Adresse des RW-Vektors
HDVMED  EQU     $47E            ; Adresse des MEDIACH-Vektors
DRVBTS  EQU     $4C2            ; Bitmaske fuer angeschlossene Laufwerke

RDBASE  EQU     $FA0000         ; Basis-Adresse der ROM-Floppy
RDMAG   EQU     $ABCDEF99       ; Magisches Langwort zur Erkennung
RDSIZE  EQU     128             ; Groesse der ROM-Floppy
RDSIZ1  EQU     125             ; Groesse der ROM-Floppy 9 KByte fuer die
;                                 Diskettenverwaltung
RDNUM   EQU     6               ; Laufwerksnummer (Laufwerk G)
RDBIT   EQU     64              ; Bit-Wert fuer Laufwerk G

GEMDOS  EQU     1               ; GEMDOS TRAP #
XBIOS   EQU     14              ; XBIOS TRAP #

KEEP    EQU     $31             ; GEMDOS #$31  Programm resident halten
SUPER   EQU     38              ; XBIOS 38  Routine im Supervisormodus
;                                 ausfuehren


; Hauptprogramm

        TEXT
XTART   BRA     ROMDSK          ; Romdisk INIT

; Tabelle des BIOS Parameter Blocks fuer die ROM-Floppy

BPBSAV  DS.L    1               ; Speicher fuer alten BPB-Vektor
RWSAV   DS.L    1               ; Speicher fuer alten RW-Vektor
MEDSAV  DS.L    1               ; Speicher fuer alten MEDIACH-Vektor

BPBTAB  DC.W    512             ; Sektorgroesse in Bytes
        DC.W    2               ; Clustergroesse in Sektoren
        DC.W    1024            ; Clustergroesse in Bytes
        DC.W    1               ; Directorylaenge in Sektoren
        DC.W    1               ; FAT-Groesse in Sektoren
        DC.W    2               ; Sektornummer des 2. FAT
        DC.W    4               ; Sektornummer des 1. Daten-Clusters
        DC.W    RDSIZ1          ; Anzahl der Daten-Cluster
        DS.W    8               ; Einige Flags


; - BPB -- BIOS Parameter Block der ROM-Floppy holen
;
; Eingaben:     4(SP)  - Laufwerksnummer
; Ausgaben:     D0     - Adresse des BIOS Parameter Blocks

BPB     BRA.S   BPB1
        DC.L    RDMAG           ; magisches Langwort fuer Test       glas
BPB1    CMP     #RDNUM,4(SP)    ; Wird die ROM-Floppy angesprochen ?
        BEQ.S   BPB2            ; Ja
        MOVE.L  BPBSAV,A0       ; Adresse des alten BPB-Vektors holen
        JMP     (A0)            ; Ausfuehren
BPB2    MOVE.L  #BPBTAB,D0      ; Adresse des BIOS Parameters Blocks
        RTS


; - RW -- Lese-Routine fuer die ROM-Floppy
; Eingaben:     4(SP)  - Schreib / Lese-Flag
;               6(SP)  - Adresse des Eingabepuffers
;               10(SP) - Anzahl der zu lesenden Sektoren
;               12(SP) - Logische Sektornummer, bei der begonnen wird
;               14(SP) - Laufwerksnummer
; Ausgaben:     D0     - Fehlercode

RW      CMP     #RDNUM,14(SP)   ; Wird die ROM-Floppy angesprochen ?
        BEQ.S   RW1             ; Ja
        MOVE.L  RWSAV,A0        ; Adresse des alten RW-Vektors holen
        JMP     (A0)            ; Ausfuehren

RW1     MOVE    10(A7),D1       ; Anzahl Sektoren
        MULU    #$20,D1         ; in Langworte ; 4 umwandeln
        MOVE.L  6(SP),A0        ; Ladeadresse
        MOVE.L  #RDBASE,A1      ; Basis Queladresse
        MOVE    12(SP),D0       ; Startsektor
        MULU    #$200,D0        ; in Bytes = Offset
        ADD.L   D0,A1           ; zur Basis
        TST     4(SP)           ; Schreiboperation ?
        BEQ     READ            ; nein, ok
        MOVE.L  #-1,D0          ; Fehler und
        RTS                     ; zurueck

READ    SUBQ.L  #1,D1           ; jeweils 16 Bytes auf einmal
TLONG   MOVE.L  (A1)+,(A0)+
        MOVE.L  (A1)+,(A0)+
        MOVE.L  (A1)+,(A0)+
        MOVE.L  (A1)+,(A0)+
        DBF     D1,TLONG
MED1    CLR.L    D0           ; Routine erfolgreich ausgefuehrt
        RTS


; - MEDIA -- Diskettenwechsel ueberpruefen
;
; Eingaben:     4(SP)  - Laufwerksnummer
; Ausgaben:     D0     - Status

MED     CMP     #RDNUM,4(SP)    ; Wird die ROM-Floppy angesprochen ?
        BEQ.S   MED1            ; Ja
        MOVE.L  MEDSAV,A0       ; Adresse des alten MEDIACH-Vektors holen
        JMP     (A0)            ; Ausfuehren



ROMDSK  LEA     RMSG(PC),A0     ; Meldung erster Teil
        BSR.S   PRTS            ; ausgeben
        MOVE.L  #$100,D6        ; Groesse der 'Base Page'
        ADD.L   #(ROMDSK-XTART),D6 ; Groesse des Codes              glas
        MOVE.L  #ROMDS1,-(SP)   ; Adresse der Initialisierungs-Routine
        MOVE    #SUPER,-(SP)    ; Im Supervisor-Modus ausfuehren
        TRAP    #XBIOS          ; XBIOS aufrufen
        ADDQ.L  #6,SP           ; Stack zuruecksetzen
        LEA     OMSG(PC),A0     ; Meldung zweiter Teil
        TST     D0              ;
        BNE.S   RDSK1           ; <> 0 wenn Romdisk vorhanden       glas
        SUB.L   D6,D6           ; 0 Bytes reservieren               glas
        LEA     NMSG(PC),A0
RDSK1   BSR.S   PRTS
        CLR     -(SP)           ;
        MOVE.L  D6,-(SP)        ; Groesse des Treibers
        MOVE    #KEEP,-(SP)     ; Programm resident halten
        TRAP    #GEMDOS         ; GEMDOS aufrufen


PRTS    MOVE.L  A0,-(SP)
        MOVE    #9,-(SP)
        TRAP    #GEMDOS
        ADDQ.L  #6,SP
        RTS

RMSG    DC.B    10,13,'ROMDISK: ',0
NMSG    DC.B    'BEREITS INSTALLIERT ODER KEINE ROMKARTE',0
OMSG    DC.B    'KORREKT INSTALLIERT',0


; - ROMD1 -- ROM-Floppy Initialisierungs-Routine (wird im Super-
;       visormodus ausgefuehrt

ROMDS1  SUB.L   D0,D0           ; retcode setzen                    glas
        LEA     RDBASE,A0       ; Anfangsadresse der ROM-Floppy
        CMP.L   #RDMAG,2(A0)    ; Magisches Langwort vorhanden ?
        BNE.S   ROMDS2          ; NEIN                              glas

        MOVE.L  HDVBPB,A0       ; Vektor laden                      glas
        CMP.L   #RDMAG,2(A0)    ; Magisches Langwort vorhanden ?    glas
        BEQ.S   ROMDS2          ; ja, nicht nochmal installieren    glas

        MOVE.L  A0,BPBSAV       ; Alten BPB-Vektor speichern
        MOVE.L  HDVRW,RWSAV     ; Alten RW-Vektor speichern
        MOVE.L  HDVMED,MEDSAV   ; Alten MEDIACH-Vektor speichern

        MOVE.L  #BPB,HDVBPB     ; Neuen BPB-Vektor setzen
        MOVE.L  #RW,HDVRW       ; Neuen RW-Vektor setzen
        MOVE.L  #MED,HDVMED     ; Neuen MEDIACH-Vektor setzen
        OR.L    #RDBIT,DRVBTS   ; ROM-Floppy als Laufwerk E anmelden
        ADDQ    #1,D0           ; Romdisk vorhanden                glas
ROMDS2  RTS
        END
