*-----------------------------------------------------------------------*
* CHANGE-ACTIVITY:                                                      *
*            ---------------------------------------------------        *
*   05.07.86    Makros in Unterroutinen verwandelt. Diese Art von       *
*               Makros kennt nur der Metacomco Assembler.               *
*                                                      glasi            *
*            ---------------------------------------------------        *
*-----------------------------------------------------------------------*

        TTL     ROMINIT
*-----------------------------------------------------------------------*
* ROMDISK-Initialisierungsprogramm fuer ATARI ST.  (c) 1986 GvS
* 14. Juni 1986
*-----------------------------------------------------------------------*

*-----------------------------------------------------------------------*
* Definition von Konstanten
*-----------------------------------------------------------------------*
HDVBPB: EQU     $472            * Adresse des BPB-Vektors
HDVRW:  EQU     $476            * Adresse des RW-Vektors
HDVMED: EQU     $47E            * Adresse des MEDIACH-Vektors
DRVBTS: EQU     $4C2            * Bitmaske fuer angeschlossene Laufwerke

RDSIZE: EQU     128             * Groesse der RAM-Disk
RDSIZ1: EQU     119             * Groesse der RAM-Disk abzueglich 9 KByte
*                                 fuer die Diskettenverwaltung
RDNUM:  EQU     3               * Laufwerksnummer (Laufwerk D)
RDBIT:  EQU     8               * Bit-Wert fuer Laufwerk D

GEMDOS: EQU     1               * GEMDOS TRAP #
XBIOS:  EQU     14              * XBIOS TRAP #

KEEP:   EQU     $31             * GEMDOS #$31: Programm resident halten
SUPER:  EQU     38              * XBIOS #38: Routine im Supervisormodus
*                                 ausfuehren
        PAGE

*-----------------------------------------------------------------------*
* Hauptprogramm
*-----------------------------------------------------------------------*
        TEXT
RAMDSK: MOVE.L  4(SP),A0        * Adresse der 'Base Page' holen
        MOVE.L  #$100,D6        * Groesse der 'Base Page'
        ADD.L   12(A0),D6       * Groesse des TEXT-Bereichs
        ADD.L   20(A0),D6       * Groesse des DATA-Bereichs
        ADD.L   28(A0),D6       * Groesse des BSS-Bereichs
        MOVE    #RDSIZE,D7      * Groesse der RAM-Disk in KByte
        LSL.L   #8,D7           * Mit 1024 multiplizieren
        LSL.L   #2,D7           *
        ADD.L   D7,D6           * Zum benoetigten Speicherplatz addieren
        MOVE.L  #RAMDS1,-(SP)   * Adresse der Initialisierungs-Routine
        MOVE    #SUPER,-(SP)    * Im Supervisor-Modus ausfuehren
        TRAP    #XBIOS          * XBIOS aufrufen
        ADDQ.L  #6,SP           * Stack zuruecksetzen
        CLR     -(SP)           *
        MOVE.L  D6,-(SP)        * Groesse des Treibers
        MOVE    #KEEP,-(SP)     * Programm resident halten
        TRAP    #GEMDOS         * GEMDOS aufrufen

*-----------------------------------------------------------------------*
* *** - RAMDS1 -- RAM-Disk Initialisierungs-Routine (wird im Super-
*-----------------------------------------------------------------------*
RAMDS1: MOVE.L  HDVBPB,BPBSAV   * Alten BPB-Vektor speichern
        MOVE.L  HDVRW,RWSAV     * Alten RW-Vektor speichern
        MOVE.L  HDVMED,MEDSAV   * Alten MEDIACH-Vektor speichern
        MOVE.L  #BPB,HDVBPB     * Neuen BPB-Vektor setzen
        MOVE.L  #RW,HDVRW       * Neuen RW-Vektor setzen
        MOVE.L  #MEDIA,HDVMED   * Neuen MEDIACH-Vektor setzen
        LEA     RAMDS,A0        * Anfangsadresse der RAM-Disk
        MOVE    #2303,D0        * Track 0 und 1 loeschen
RAM1    CLR.L   (A0)+           *
        DBRA    D0,RAM1         *
        LEA     RAMDS,A0        * Anfangsadresse der RAM-Disk
        MOVE.L  #$ABCDEF99,2(A0) * Magisches Langwort erzeugen
        LEA     11(A0),A0       * Zeiger auf Datenbereich setzen
        LEA     BOOTAB,A1       * Tabelle fuer Bootsektor laden
        MOVEQ   #TABEND-BOOTAB-1,D0 * Groesse der Tabelle berechnen
RAM2    MOVE.B  (A1)+,(A0)+     * Daten in Bootsektor kopieren
        DBRA    D0,RAM2         *
        OR.L    #RDBIT,DRVBTS   * RAM-Disk als Laufwerk D anmelden
        RTS

*-----------------------------------------------------------------------*
* *** - BPB -- BIOS Parameter Block der RAM-Disk holen
* Eingaben:     4(SP)  - Laufwerksnummer
* Ausgaben:     D0     - Adresse des BIOS Parameter Blocks
*-----------------------------------------------------------------------*
BPB:    CMP     #RDNUM,4(SP)    * Wird die RAM-Disk angesprochen ?
        BEQ.S   BPB1            * Ja
        MOVE.L  BPBSAV,A0       * Adresse des alten BPB-Vektors holen
        JMP     (A0)            * Ausfuehren
BPB1    MOVE.L  #BPBTAB,D0      * Adresse des BIOS Parameters Blocks
        RTS
*-----------------------------------------------------------------------*
* *** - RW -- Schreib / Lese-Routine fuer die RAM-Disk
* Eingaben:     4(SP)  - Schreib / Lese-Flag
*               6(SP)  - Adresse des Eingabepuffers
*               10(SP) - Anzahl der zu lesenden / schreibenden Sektoren
*               12(SP) - Logische Sektornummer, bei der begonnen wird
*               14(SP) - Laufwerksnummer
* Ausgaben:     D0     - Fehlercode
*-----------------------------------------------------------------------*
RW:     CMP     #RDNUM,14(SP)   * Wird die RAM-Disk angesprochen ?
        BEQ.S   RW1             * Ja
        MOVE.L  RWSAV,A0        * Adresse des alten RW-Vektors holen
        JMP     (A0)            * Ausfuehren
RW1:    MOVE    12(SP),D0       * Logische Sektornummer holen
        EXT.L   D0              *
        LSL.L   #8,D0           * Mit 512 multiplizieren
        LSL.L   #1,D0           *
        MOVE.L  6(SP),A0        * Adresse des Puffers holen
        MOVE    10(SP),D1       * Anzahl der zu lesenden Sektoren
        SUBQ    #1,D1           * Minus 1
        LEA     RAMDS,A1        * Anfangsadresse der RAM-Disk
        ADD.L   D0,A1           * Offset addieren
        MOVE    4(SP),D0        * Schreib / Lese-Flag holen
        BTST    #0,D0           * Lesezugriff ?
        BEQ.S   RW2             * Ja
        EXG     A0,A1           * Ziel und Quelle austauschen
RW2:    MOVE    #511,D0         * Groesse eines Sektors
RW3:    MOVE.B  (A1)+,(A0)+     * Puffer kopieren
        DBRA    D0,RW3          *
        DBRA    D1,RW2          *
        MOVEQ   #0,D0           * Routine erfolgreich ausgefuehrt
        RTS

*-----------------------------------------------------------------------*
*+
* *** - MEDIA -- Diskettenwechsel ueberpruefen
*
* Eingaben:     4(SP)  - Laufwerksnummer
* Ausgaben:     D0     - Status
*
*-
*-----------------------------------------------------------------------*
MEDIA:  CMP     #RDNUM,4(SP)    * Wird die RAM-Disk angesprochen ?
        BEQ.S   MED1            * Ja
        MOVE.L  MEDSAV,A0       * Adresse des alten MEDIACH-Vektors holen
        JMP     (A0)            * Ausfuehren
MED1    MOVEQ   #0,D0           * Diskette wurde nicht gewechselt (wie auch?)
        RTS

*-----------------------------------------------------------------------*
*+
*
* Tabelle des BIOS Parameter Blocks fuer die RAM-Disk
*
*-
*-----------------------------------------------------------------------*
        DATA
BPBTAB: DC.W    512             * Sektorgroesse in Bytes
        DC.W    2               * Clustergroesse in Sektoren
        DC.W    1024            * Clustergroesse in Bytes
        DC.W    7               * Directorylaenge in Sektoren
        DC.W    5               * FAT-Groesse in Sektoren
        DC.W    6               * Sektornummer des 2. FAT
        DC.W    18              * Sektornummer des 1. Daten-Clusters
        DC.W    RDSIZ1          * Anzahl der Daten-Cluster
        DS.W    8               * Einige Flags

*-----------------------------------------------------------------------*
*+
*
* Tabelle fuer die Daten im Boot-Sektor
*
*-
*-----------------------------------------------------------------------*
BOOTAB: DC.B    0,2             * Bytes pro Sektor
        DC.B    2               * Sektoren pro Cluster
        DC.B    1,0             * Reservierte Sektoren
        DC.B    2               * Anzahl der FATs
        DC.B    112,0           * Anzahl der Directory-Eintraege
        DC.B    RDSIZ1,0        * Anzahl der Sektoren
        DC.B    0               *
        DC.B    5,0             * Sektoren pro FAT
        DC.B    9,0             * Sektoren pro Track
        DC.B    1,0             * Seiten auf der Diskette
        DC.B    0               * Versteckte Sektoren
TABEND: EQU     *

*-----------------------------------------------------------------------*
        BSS
BPBSAV: DS.L    1               * Speicher fuer alten BPB-Vektor
RWSAV:  DS.L    1               * Speicher fuer alten RW-Vektor
MEDSAV: DS.L    1               * Speicher fuer alten MEDIACH-Vektor

RAMDS:  EQU     *               * Hier beginnt die RAM-Disk~

        END

