; ROMDISK-Treiber im BOOT-Sektor der ROM-Disk selber (TURBOASS).
; ju 15.12.92 / V8.0

                DC.L $ABCDEF42,0,$48FA0028
                DC.B $02        ; $200 = 512 Bytes/Sektor (12+11)
                DC.B $02        ; 2 Sektoren/Cluster      (13)
                DC.W $0100      ; 1 reservierter Sektor   (15+14)
                DC.B $02        ; 2 FAT                   (16)
                DC.B $10
                DC.B $00        ; 16 Dir-Eintrge         (18+17)
                DC.B $00
                DC.B $01        ; 256 Sektoren/Disk       (20+19)
                DC.B $00        ; MEDIA-Byte              (21)
                DC.W $0100      ; Sektoren/FAT            (23+22)
                DC.W $0900      ; Sektoren/Spur           (25+24)
                DC.W $0100      ; Anzahl Seiten           (27+26)
                DC.W $00        ; versteckte Sekt.        (29+28)
                DC.B 'ROM-DISK',0

                EVEN

                move.l  #$0200,-(SP)    ; 512 Bytes Speicher holen
                move.w  #$48,-(SP)
                trap    #1
                addq.l  #6,SP
                movea.l D0,A1           ; D0 = Anfangsadresse Speicher
                movea.l D0,A2
                move.w  #$0200,D0       ; residentes Prg. verschieben...
                lsr.w   #1,D0
                lea     L1005E(PC),A0
L10056:         move.w  (A0)+,(A1)+
                dbra    D0,L10056
                jmp     (A2)            ; ... und starten

L1005E:         bra     L10104          ; Installationsprg. starten
L1006E:         DC.W $0200      ; Sektorgroesse in Bytes
                DC.W 2          ; Clustergroesse in Sektoren
                DC.W $0400      ; Clustergroesse in Bytes
                DC.W 1          ; Directorylaenge in Sektoren
                DC.W 1          ; FAT-Groesse in Sektoren
                DC.W 2          ; Sektornummer des 2. FAT
                DC.W 4          ; Sektornummer des 1. Daten-Clusters
                DC.W $7E        ; Anzahl der Daten-Cluster
                DC.W 0          ; Einige Flags
                DC.W 0,0,0,0,0,0,0


; - BPB -- BIOS Parameter Block der ROM-Floppy holen
;
; Eingaben:     4(SP)  - Laufwerksnummer
; Ausgaben:     D0     - Adresse des BIOS Parameter Blocks

                DC.B 'XBRA'     ;XBRA-Protokoll-Kennung
                DC.L 'ROMD'     ;Eigene Kennung
old_bpb:        DS.L 1          ;Die alte Vektoradresse
L1008E:         cmpi.w  #11,4(SP)       ; 'L'?
                beq.s   L100A2
                movea.l old_bpb(PC),A0
                jmp     (A0)
L100A2:         lea     L1006E(PC),A0
                move.l  A0,D0
                rts


; - RW -- Lese-Routine fuer die ROM-Floppy
; Eingaben:     4(SP)  - Schreib / Lese-Flag
;               6(SP)  - Adresse des Eingabepuffers
;               10(SP) - Anzahl der zu lesenden Sektoren
;               12(SP) - Logische Sektornummer, bei der begonnen wird
;               14(SP) - Laufwerksnummer
; Ausgaben:     D0     - Fehlercode

                DC.B 'XBRA'     ;XBRA-Protokoll-Kennung
                DC.L 'ROMD'     ;Eigene Kennung
old_rw:         DS.L 1          ;Die alte Vektoradresse
L100AA:         cmpi.w  #11,$0E(SP)     ; 'L'?
                beq.s   L100B8
                movea.l old_rw(PC),A0
                jmp     (A0)
L100B8:         move.w  $0A(SP),D1
                mulu    #$20,D1
                movea.l 6(SP),A0
                movea.l #$FA0000,A1
                move.w  $0C(SP),D0
                mulu    #$0200,D0
                adda.l  D0,A1
                tst.w   4(SP)
                beq.s   L100E4
                move.l  #$FFFFFFFF,D0
                rts
L100E4:         subq.l  #1,D1
L100E6:         move.l  (A1)+,(A0)+
                move.l  (A1)+,(A0)+
                move.l  (A1)+,(A0)+
                move.l  (A1)+,(A0)+
                dbra    D1,L100E6
L100F2:         moveq   #0,D0
                rts


; - MEDIA -- Diskettenwechsel ueberpruefen
;
; Eingaben:     4(SP)  - Laufwerksnummer
; Ausgaben:     D0     - Status

                DC.B 'XBRA'     ;XBRA-Protokoll-Kennung
                DC.L 'ROMD'     ;Eigene Kennung
old_media:      DS.L 1          ;Die alte Vektoradresse
L100F6:         cmpi.w  #11,4(SP)       ;'L'?
                beq.s   L100F2
                movea.l old_media(PC),A0
                jmp     (A0)




; Installationsprogramm:

L10104:         movem.l D0/A0,-(SP)     ; 'ROMDISK:' ausgeben
                lea     L101A0(PC),A0
                bsr     L10194

LOOP:           cmpi.l  #300,$04BA.w    ; Zeit nach Kaltstart vorbei?
                ble.s   LOOP            ; nein, noch warten
                move.w  #-1,-(SP)       ; Status holen
                move.w  #$0B,-(SP)      ; Kbshift
                trap    #13             ; BIOS
                addq.l  #4,SP
                lea     L101C5(PC),A0   ; Abbruch-Text
                and.w   #%10,D0         ; linke SHIFT-Taste
                bne     L1018C          ; gedrckt => Abbruch

                sub.l   D0,D0
                lea     $FA0000,A0
                cmpi.l  #$EF420000,2(A0)
                bne.s   L1017E          ; ROMDISK nicht vorhanden
                movea.l $0472.w,A0
                cmpi.l  #'ROMD',-8(A0)
                beq.s   L1017E          ; ROMDISK schon installiert

                lea     old_bpb(PC),A0  ; alte Vektoren sichern
                move.l  $0472.w,(A0)
                lea     old_rw(PC),A0
                move.l  $0476.w,(A0)
                lea     old_media(PC),A0
                move.l  $047E.w,(A0)

                lea     L1008E(PC),A0   ; neue Vektoren inst.
                move.l  A0,$0472.w
                lea     L100AA(PC),A0
                move.l  A0,$0476.w
                lea     L100F6(PC),A0
                move.l  A0,$047E.w

                ori.l   #%100000000000,$04C2.w ; drvmap-Bit setzen
                move.w  #11,$0446.w     ; Bootlaufwerk
                move.b  #11,$0446.w
                move.w  #11,-(SP)
                move.w  #$0E,-(SP)      ;Dsetdrv
                trap    #1              ;GEMDOS
                addq.l  #4,SP
                addq.w  #1,D0

L1017E:         lea     L101B5(PC),A0   ;Ok-Meldung
                tst.w   D0
                bne.s   L1018C          ;Ok-Meldung
                sub.l   D6,D6
                lea     L101AC(PC),A0   ;Fehlermeldung
L1018C:         bsr.s   L10194          ;Ausgabe
                movem.l (SP)+,D0/A0
                rts


;Unterroutine fr Ausgabe String

L10194:         move.l  A0,-(SP)
                move.w  #9,-(SP)        ;Cconws
                trap    #1              ;GEMDOS
                addq.l  #6,SP
                rts


L101A0:         DC.B $0A,$0D,'L: - ROMDISK: ',0
L101AC:         DC.B 'Fehler !',$0D,$0A,0
L101B5:         DC.B 'Version 8.0 Ok.',$0D,$0A,0
L101C5:         DC.B 'Abbruch !',$0D,$0A,0

                END
